//****************************************************************************
//	aisa10w.pas
//
//	aISA-P10
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/27
//
//****************************************************************************

unit aisa10w;

interface

uses
	Windows;

{ Errors }

const
	AISA10_SUCCESS							= 0;	 { ُȂ }
	AISA10_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA10_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA10_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA10_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA10_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA10_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA10_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Port numbers }

const
	AISA10_PORT_0	= 0;
	AISA10_PORT_1	= 1;


{ Miscellaneous }

const
	AISA10_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA10_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA10_DLL_NAME = 'aisa10.dll';		{ DLL }

function Aisa10wDllOpen: Boolean;			{ DLL [h }
function Aisa10wDllClose: Boolean;		{ DLL A[h }


const
	AISA10_SLOT_AUTO = $ffff;

{ aISA-P10 DLL,Driver̃o[Wԍ擾 }
function Aisa10wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P10̎gp錾 }
function Aisa10wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P10̎gpJ }
function Aisa10wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA10_MAX_MEM	=	 9;
		AISA10_MAX_IO		= 20;
		AISA10_MAX_IRQ	=	 7;
		AISA10_MAX_DMA	=	 7;

type
		TAISA10RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA10_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA10_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA10_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA10_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA10_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA10_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA10_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA10_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA10_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA10RESOURCE = ^TAISA10RESOURCE;

{ \[X擾 }
function Aisa10wGetResource(wLogSlot: Word;  pResInfo: PAISA10RESOURCE): Boolean;

{ Cӂ̃|[gf[^ }
function Aisa10wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa10wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;


{ aISA-P10̃G[R[h }
function Aisa10wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa10GetVersion = function(var pdwDllVer: DWORD; var pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa10Create = function(var pwLogSlot: Word): BOOL; stdcall;
	TAisa10Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa10GetResource = function(wLogSlot: WORD; res: PAISA10RESOURCE):	BOOL; stdcall;
	TAisa10InPort = function(wLogSlot: WORD; dwLogPort: DWORD; var lpbInValue: BYTE): BOOL; stdcall;
	TAisa10OutPort = function(wLogSlot: WORD; dwLogPort: DWORD; bOutValue: BYTE): BOOL; stdcall;
	TAisa10GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa10wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa10GetVersion: TAisa10GetVersion;
	pAisa10Create: TAisa10Create;
	pAisa10Close: TAisa10Close;
	pAisa10GetResource: TAisa10GetResource;
	pAisa10InPort: TAisa10InPort;
	pAisa10OutPort: TAisa10OutPort;
	pAisa10GetLastError: TAisa10GetLastError;


//****************************************************************************
// @\			aisa10.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa10wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA10_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa10wGetDllExportFunc = False then
  begin
       Aisa10wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa10.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa10wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-P10 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drivero[Wԍi[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa10wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa10GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-P10̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa10wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa10Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-P10̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa10wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa10Close(wLogSlot);
end;


//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa10wGetResource(wLogSlot: Word;  pResInfo: PAISA10RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa10GetResource(wLogSlot, pResInfo);
end;


//****************************************************************************
// @\			Cӂ̃|[gf[^
// 			wLogSlot	--- ͂foCX
//					dwPort		--- ͂|[g
//					pbInValue --- ̓f[^i[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa10wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa10InPort(wLogSlot, dwPort, pbInValue);
end;

//****************************************************************************
// @\			Cӂ̃|[gփf[^o
// 			wLogSlot	--- o͂foCX
//					dwPort		--- o͂|[g
//					bOutValue --- o͂f[^
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa10wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa10OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// @\			aISA-P10̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa10wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA10_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa10GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa10wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa10GetVersion ̃AhX擾
	pAisa10GetVersion := GetProcAddress(hDLL, 'Aisa10GetVersion');
	if @pAisa10GetVersion = nil then Exit;

	// Aisa10Create ̃AhX擾
	pAisa10Create := GetProcAddress(hDLL, 'Aisa10Create');
	if @pAisa10Create = nil then Exit;

	// Aisa10Close ̃AhX擾
	pAisa10Close := GetProcAddress(hDLL, 'Aisa10Close');
	if @pAisa10Close = nil then Exit;

	// Aisa10GetResource ̃AhX擾
	pAisa10GetResource := GetProcAddress(hDLL, 'Aisa10GetResource');
	if @pAisa10GetResource = nil then Exit;

	// Aisa10InPort ̃AhX擾
	pAisa10InPort := GetProcAddress(hDLL, 'Aisa10InPort');
	if @pAisa10InPort = nil then Exit;

	// Aisa10OutPort ̃AhX擾
	pAisa10OutPort := GetProcAddress(hDLL, 'Aisa10OutPort');
	if @pAisa10OutPort = nil then Exit;

	// Aisa10GetLastError ̃AhX擾
	pAisa10GetLastError := GetProcAddress(hDLL, 'Aisa10GetLastError');
	if @pAisa10GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

